--[[
-- Copyright (c) 2011-2012  Anton Savoshchanka (aka AntonioModer)
--
-- This software is provided 'as-is', without any express or implied
-- warranty.  In no event will the authors be held liable for any damages
-- arising from the use of this software.
--
-- Permission is granted to anyone to use this software for any purpose,
-- including commercial applications, and to alter it and redistribute it
-- freely, subject to the following restrictions:
--
-- 1. The origin of this software must not be misrepresented; you must not
--    claim that you wrote the original software. If you use this software
--    in a product, an acknowledgment in the product documentation would be
--    appreciated but is not required.
-- 2. Altered source versions must be plainly marked as such, and must not be
--    misrepresented as being the original software.
-- 3. This notice may not be removed or altered from any source distribution.
--]]

 function initGame()

-- initial graphics setup
love.graphics.setBackgroundColor(104, 136, 248) -- color = blue
-- initial	PHYSICS
love.physics.setMeter(64) 
-- physWorld = love.physics.newWorld(0, 10*64, true)
physWorld = love.physics.newWorld(0, 0, true)

-- INIT class Entity 
do -- Entity 

class "Entity" {
-- init var !!!
	x =0;
	y =0;
	idCount = 0;	
	objNameIndex = "nil";	
	id = {};	
	physFixturePoly={};		--  
	physShapePoly={};		-- ...
}
function Entity:__init(x, y, objNameIndex)
	self.x =x;                                              
	self.y =y;		
	self.idCount = globalEntityCount+1;
	globalEntityCount = self.idCount;
	self.objNameIndex = objNameIndex;
	-- !!!           !!!
	self.physFixturePoly={};		--  
	self.physShapePoly={};		-- ...	
	self.id = {};	
end

-- tableVertices -  
-- TODO:
--			   
--			 self.physShapeType == 3  self.physShapeType == 4
function Entity:setPhysBody(physBodyType, physShapeType, RectangleWidth, RectangleHeight, tableVertices, tableObjId)
	-- -- physBodyType = "static"; "dynamic"		
	-- -- physShapeType =  1: circle; 2: Rectangle; 3: Tr; 4: 		
	
	-- -- ID = tabEntitys.Triangle2.physFixture:getUserData()			--  idObj  fixture   !!!
	self.id = tableObjId;																-- for slice !!!
	-- print('self.id= '..tostring(self.id));
	
	-- self.phys_body_RectangleWidth = RectangleWidth;		
	-- self.phys_body_RectangleHeight = RectangleHeight;		
	self.physBodyType = physBodyType;
	self.physShapeType = physShapeType;
	
	self.physBody = love.physics.newBody(physWorld, self.x, self.y, self.physBodyType); --place the body in the center of the world and make it dynamic, so it can move around
	
	if self.physShapeType== 4 and #tableVertices == 6 then	--   - 3-
		self.physShapeType = 3
	end		
		
	if physBodyType == "dynamic" then
		self.physBody:setMass(15);
		-- self.physBody:setMassData( self.x, self.y, 15, 0 )
		-- self.physBody:setBullet(true);															--     !!!				
	end
	
	if self.physShapeType == 1 then
		self.physShape = love.physics.newCircleShape(20);
		self.physFixture = love.physics.newFixture(self.physBody, self.physShape, 1);	
		self.physFixture:setRestitution(0);												-- bounce, def = 1	
		self.physFixture:setUserData( self.id );
	end
	if self.physShapeType == 2 then
		self.physShape = love.physics.newRectangleShape(RectangleWidth, RectangleHeight);
		self.physFixture = love.physics.newFixture(self.physBody, self.physShape, 1);	
		self.physFixture:setRestitution(0);												-- bounce, def = 1			
		self.physFixture:setUserData( self.id );			
	end
	if self.physShapeType == 3 then
		-- -- (-self.x, -self.y) -     
		-- self.physShape = love.physics.newPolygonShape( 
			-- tableVertices[1], tableVertices[2], tableVertices[3], tableVertices[4], 
			-- tableVertices[5], tableVertices[6]);
		-- -- self.physShape = love.physics.newPolygonShape( self.x-50-self.x, self.y+10-self.y, self.x-self.x, self.y-50-self.y, self.x+50-self.x, self.y+10-self.y );
		-- -- self.physShape = love.physics.newPolygonShape( self.x, self.y, self.x+50, self.y-50, self.x+70, self.y );
		-- -- self.physBody:setMassData( self.x, self.y, 15, 1 );			
		-- self.physFixture = love.physics.newFixture(self.physBody, self.physShape, 1);	
		-- self.physFixture:setRestitution(0);											-- bounce, def = 1		
		-- self.physFixture:setUserData( self.id );
		

		self.physShapePoly[1] = love.physics.newPolygonShape( 
			tableVertices[1], tableVertices[2], tableVertices[3], tableVertices[4], 
			tableVertices[5], tableVertices[6]);
		self.physFixturePoly[1] = love.physics.newFixture(self.physBody, self.physShapePoly[1], 1);
		self.physFixturePoly[1]:setUserData( self.id ); -- ID
		

	end
	if self.physShapeType == 4 then													-- BUG !!!
	-- 
		local tableNewShape=triangulate(tableVertices);
		-- print("NO BUG physShapeType == 4 -"..self.objNameIndex..' - '..tostring(self.id))
		
		-- for tr=1, #tableNewShape do														--    (debug)
			-- print("\n".."triangle "..tr)
			-- print(tableNewShape[tr].x1, tableNewShape[tr].y1)
			-- print(tableNewShape[tr].x2, tableNewShape[tr].y2)
			-- print(tableNewShape[tr].x3, tableNewShape[tr].y3)
		-- end

		--    body   fixture
		for tr=1, #tableNewShape do
			self.physShapePoly[tr] = love.physics.newPolygonShape( 
				tableNewShape[tr].x1, tableNewShape[tr].y1,
				tableNewShape[tr].x2, tableNewShape[tr].y2,
				tableNewShape[tr].x3, tableNewShape[tr].y3);	
			self.physFixturePoly[tr] = love.physics.newFixture(self.physBody, self.physShapePoly[tr], 1);
			self.physFixturePoly[tr]:setUserData( self.id ); -- ID
			
		end
		--print("\n".."for tr=1, #tableNewShape do")
	end
	
end

end  -- Entity --------------------------------------------------------------

do -- EntityBlock

class "EntityBlock" {
-- init var !!!
	x =0;
	y =0;	
}
function EntityBlock:__init(x, y)
	self.x =x;                                              
	self.y =y;		
end

function EntityBlock:setPhysBody(physBodyType, physShapeType, RectangleWidth, RectangleHeight)
	-- physBodyType = "static"; "dynamic"		
	-- physShapeType =  1: circle; 2: Rectangle		
	self.physBodyType = physBodyType;
	self.physShapeType = physShapeType;
	self.physBody = love.physics.newBody(physWorld, self.x, self.y, self.physBodyType); --place the body in the center of the world and make it dynamic, so it can move around
	
	if physBodyType == "dynamic" then
		self.physBody:setMass(15);
		self.physBody:setBullet(true);				
	end
	
	if self.physShapeType == 1 then
		self.physShape = love.physics.newCircleShape(20);
	else
		self.physShape = love.physics.newRectangleShape(RectangleWidth, RectangleHeight);
	end
	self.physFixture = love.physics.newFixture(self.physBody, self.physShape, 1);
	self.physFixture:setRestitution(2); -- bounce		
	
end -- EntityBlock

end



end 
