--[[
-- Copyright (c) 2012  Anton Savoshchanka (aka AntonioModer)
--
-- This software is provided 'as-is', without any express or implied
-- warranty.  In no event will the authors be held liable for any damages
-- arising from the use of this software.
--
-- Permission is granted to anyone to use this software for any purpose,
-- including commercial applications, and to alter it and redistribute it
-- freely, subject to the following restrictions:
--
-- 1. The origin of this software must not be misrepresented; you must not
--    claim that you wrote the original software. If you use this software
--    in a product, an acknowledgment in the product documentation would be
--    appreciated but is not required.
-- 2. Altered source versions must be plainly marked as such, and must not be
--    misrepresented as being the original software.
-- 3. This notice may not be removed or altered from any source distribution.
--]]

--[[
Love_Draw
--]]


function loveDraw()
-- love.graphics.setPointStyle( "rough" )		
-- love.graphics.setLineStyle( "rough" )	
-- love.graphics.setLineWidth(1)
love.graphics.setPointSize(5)

-- fps in caption ------------------------------------------------
fps = love.timer.getFPS()	;
love.graphics.setCaption("Prototype v 0.8"..", by AntonioModer".." (mant.base@yandex.ru)", 0, 0);
------------------------------------------------------------------


for i, v in pairs(tabEntitys) do		
	
	love.graphics.setColor(72, 160, 14); -- green		
	if v.physShapeType == 1 then
		love.graphics.circle("fill", v.physBody:getX(), v.physBody:getY(), v.physShape:getRadius())
		love.graphics.setColor(0, 255, 255, 255)
		love.graphics.circle("line", v.physBody:getX(), v.physBody:getY(), v.physShape:getRadius())
	end
	if v.physShapeType == 2 then
		love.graphics.polygon("fill", v.physBody:getWorldPoints(v.physShape:getPoints()))
		love.graphics.setColor(0, 255, 255, 255)	
		love.graphics.polygon("line", v.physBody:getWorldPoints(v.physShape:getPoints()))
		-- -- draw all point of body (draw slow)-----------------------------------------
		-- tabShapeVert ={};
		-- tabShapeVert = {v.physBody:getWorldPoints(v.physShape:getPoints()) };
		-- --print(tabShapeVert[6])
		-- for i=1, #tabShapeVert/2  do
			-- love.graphics.point(tabShapeVert[i+i-1], tabShapeVert[i+i])		
		-- end		
		--------------------------------------------------------------------
		love.graphics.setColor(255, 255, 0, 255)	
		love.graphics.print( tostring(v.objNameIndex),v.physBody:getX(), v.physBody:getY())	            -- get objNameIndex         	

	end
	if v.physShapeType == 3 then
		love.graphics.polygon("fill", v.physBody:getWorldPoints(v.physShapePoly[1]:getPoints()))	--  !!!
		love.graphics.setColor(0, 255, 255, 255)
		-- -- draw all point of body (draw slow)-----------------------------------------
		-- tabShapeVert ={};
		-- tabShapeVert = {v.physBody:getWorldPoints(v.physShape:getPoints()) };
		-- --print(tabShapeVert[6])
		-- for i=1, #tabShapeVert/2  do
			-- love.graphics.point(tabShapeVert[i+i-1], tabShapeVert[i+i])		
		-- end			
		-------------
		-- -- draw new center of body-------------------------------------------
		-- love.graphics.setColor(0, 255, 255, 255)
		-- local xc = 0;
		-- local yc = 0;
		-- xc, yc = findCenterDraw(v)
		-- love.graphics.point(xc, yc)	
		-- love.graphics.setColor(72, 160, 14);									-- green
		-- -------------------------------------------------------------------	
		-- -- or 1
		-- i=1
		-- love.graphics.triangle( "line",  tabShapeVert[i+i-1], tabShapeVert[i+i], 
			-- tabShapeVert[(i+1)+((i+1)-1)], tabShapeVert[(i+1)+(i+1)], 
			-- tabShapeVert[(i+2)+((i+2)-1)], tabShapeVert[(i+2)+(i+2)] )
		-- -- or 2
		-- love.graphics.polygon("line", v.physBody:getWorldPoints(v.physShapePoly[1]:getPoints()))		-- def	
		
		--   
		vx, vy  = v.physBody:getLinearVelocityFromLocalPoint( 0, 0 )	
		xx = v.physBody:getX()
		yy = v.physBody:getY()
		
		-- local getMDX, getMDY = v.physBody:getMassData()							--    
		-- getMDX, getMDY = v.physBody:getWorldPoint(getMDX, getMDY)
		
		dir = math.angle(xx, yy, xx+vx, yy+vy)	
		ldx = lengthdirX(50, math.deg(dir))
		ldy = lengthdirY(50, math.deg(dir))
		
		love.graphics.setColor(255, 255, 0)	
		love.graphics.line(xx, yy, xx+ldx, yy+ldy);									--  
	end
	
	if v.physShapeType == 4 then		

		for tr=1, #v.physShapePoly do
			local fixture =v.physFixturePoly[tr];
			local shape = fixture:getShape();
			love.graphics.polygon("fill", v.physBody:getWorldPoints(shape:getPoints()))
			
			love.graphics.setColor(0, 255, 255, 255)
			-- -- draw all point of body (draw slow)-----------------------------------------
			-- tabShapeVert ={};
			-- tabShapeVert = {v.physBody:getWorldPoints(v.physShapePoly[tr]:getPoints()) };
			-- --print(tabShapeVert[6])
			-- for i=1, #tabShapeVert/2  do
				-- love.graphics.point(tabShapeVert[i+i-1], tabShapeVert[i+i])		
			-- end				
			-- -- or 1
			-- love.graphics.polygon("line", v.physBody:getWorldPoints(v.physShapePoly[tr]:getPoints()))		-- def		
			-- -- or 2
			-- love.graphics.triangle( "line",  tabShapeVert[tr+tr-1], tabShapeVert[tr+tr], 
				-- tabShapeVert[(tr+1)+((tr+1)-1)], tabShapeVert[(tr+1)+(tr+1)], 
				-- tabShapeVert[(tr+2)+((tr+2)-1)], tabShapeVert[(tr+2)+(tr+2)] )
			
			love.graphics.setColor(72, 160, 14);									-- green		
		end
		-- -- draw new center of body-------------------------------------------
		-- love.graphics.setColor(0, 255, 255, 255)
		-- local xc = 0;
		-- local yc = 0;
		-- xc, yc = findCenterDraw(v)
		-- love.graphics.point(xc, yc)	
		-- love.graphics.setColor(72, 160, 14);									-- green
		-- -------------------------------------------------------------------		
		
		--   
		vx, vy  = v.physBody:getLinearVelocityFromLocalPoint( 0, 0 )	
		xx = v.physBody:getX()
		yy = v.physBody:getY()
		
		-- local getMDX, getMDY, mass, inertia  = v.physBody:getMassData()							--    
		-- getMDX, getMDY = v.physBody:getWorldPoint(getMDX, getMDY)
		-- print(getMDX, getMDY)
		
		dir = math.angle(xx, yy, xx+vx, yy+vy)	
		ldx = lengthdirX(50, math.deg(dir))
		ldy = lengthdirY(50, math.deg(dir))
		
		love.graphics.setColor(255, 255, 0)	
		love.graphics.line(xx, yy, xx+ldx, yy+ldy);									--  
		
	end	
	
	love.graphics.setColor(255, 255, 255, 100)								-- 
	love.graphics.point(v.physBody:getX(), v.physBody:getY())			--   
	-- massX, massY, mass, inertia = v.physBody:getMassData();
	-- love.graphics.point(massX, massY)			-- 
	-- print(massX, massY)			-- 
	
	--    
	local getMDX, getMDY = v.physBody:getMassData()
	getMDX, getMDY = v.physBody:getWorldPoint(getMDX, getMDY)
	love.graphics.setColor(255, 255, 0)												-- 
	-- love.graphics.print( tostring(v.objNameIndex), v.physBody:getX(), v.physBody:getY())
	love.graphics.point(getMDX, getMDY)			--    
	
	
	--	     
	-- local ldx1 = lengthdirX(50, -math.deg(v.physBody:getAngle()))
	-- local ldy1 = lengthdirY(50, -math.deg(v.physBody:getAngle()))
	-- love.graphics.point(v.physBody:getX()+ldx1, v.physBody:getY()+ldy1);
	
	-- local xx = v.physBody:getX()
	-- local yy = v.physBody:getY()

	-- love.graphics.setColor(0, 0, 0)
	-- ldx2 = lengthdirX(20, math.deg(v.physBody:getAngle()))
	-- ldy2 = lengthdirY(20, math.deg(v.physBody:getAngle()))
	-- love.graphics.line(xx, yy, xx+ldx2, yy+ldy2)		

end	

-- WORLD RAY
-- if globalTest == true then
	-- 1 --------------------------
	-- Drawing the ray.
	love.graphics.setColor(255, 255, 255, 100)
	love.graphics.line(ray1.x1, ray1.y1, ray1.x2, ray1.y2)
	
	-- Drawing the intersection points and normal vectors if there were any.
	-- for i = 1, #ray1.hitList do
		-- local hit = ray1.hitList[i]
		-- love.graphics.setColor(255, 0, 0)
		-- love.graphics.circle("line", hit.x, hit.y, 3)
		-- love.graphics.setColor(255, 255, 0, 255)	
		-- love.graphics.print( tostring((hit.fixture:getUserData()).objNameIndex),hit.x, hit.y)	            -- get objNameIndex         	
		-- love.graphics.setColor(0, 255, 0)
		-- love.graphics.line(hit.x, hit.y, hit.x+hit.xn/2, hit.y+hit.yn/2)
		--     
		-- if iii == 1 then
			-- ObjID = {};
			-- ObjID = hit.fixture:getUserData();		
			-- -- ObjID.physBody:destroy();
		-- end
		-- iii = 1	

	-- end
	-- 2 --------------------------------
	-- -- Drawing the ray.
	-- love.graphics.setColor(255, 255, 0, 255)
	-- love.graphics.line(ray2.x1, ray2.y1, ray2.x2, ray2.y2)
	
	-- -- Drawing the intersection points and normal vectors if there were any.
	-- for i = 1, #ray1.hitList do
		-- local hit = ray2.hitList[i]
		-- love.graphics.setColor(255, 255, 0)
		-- love.graphics.circle("line", hit.x, hit.y, 3)
		-- love.graphics.setColor(255, 255, 0, 255)		
		-- love.graphics.print( tostring((hit.fixture:getUserData()).objNameIndex),hit.x, hit.y)	            -- get objNameIndex
		-- love.graphics.setColor(0, 255, 0)
		-- love.graphics.line(hit.x, hit.y, hit.x+hit.xn/2, hit.y+hit.yn/2)
	-- end
	-- -------------------------------------------------------------
	------------------------------------------------------------------------------------------------------------
-- end
love.graphics.setColor(0, 0, 0)
love.graphics.print("FPS = "..fps
	.."\n-1  ".."Press escape to exit."
	.."\n-2  ".."Press mouse left button to add point ray."
	.."\n-3  ".."Press enter to slice."
	.."\n-4  ".."Press arrows to move board."
	.."\n-5  "..love.mouse.getX()..", "..love.mouse.getY()
	, 5, 5);

-- TEST ==============
-- local tab1 = rayCastGetBody(ray1.hitList);
-- print(tab1)
-- tab1 = nil;	

-- obj = tabEntitys['_9'];
-- if obj ~= nil then
	-- fixture =obj.physFixturePoly[1];
	-- shape = fixture:getShape();
	
	-- -- print(obj.physFixturePoly[1]:getUserData());
	
	-- if obj.physShapeType == 4 then
		-- love.graphics.polygon("fill", obj.physBody:getWorldPoints(shape:getPoints()));
	-- end

-- end

end	-- loveDraw()