--[[
-- Copyright (c) 2012  Anton Savoshchanka (aka AntonioModer)
--
-- This software is provided 'as-is', without any express or implied
-- warranty.  In no event will the authors be held liable for any damages
-- arising from the use of this software.
--
-- Permission is granted to anyone to use this software for any purpose,
-- including commercial applications, and to alter it and redistribute it
-- freely, subject to the following restrictions:
--
-- 1. The origin of this software must not be misrepresented; you must not
--    claim that you wrote the original software. If you use this software
--    in a product, an acknowledgment in the product documentation would be
--    appreciated but is not required.
-- 2. Altered source versions must be plainly marked as such, and must not be
--    misrepresented as being the original software.
-- 3. This notice may not be removed or altered from any source distribution.
--]]

--[[
TODO:
	slice(...)
	slice 2 triangles
	new concaveToConvex()	
	slice convex

--]]

require 'loveKeypressed'
require 'loveDraw'
require 'loveLoad'
require 'loveUpdate'
require 'oo32lines'
require 'math2'
require 'initGame'
require 'slice'
require 'loveRun'


-- Collision detection function.
-- Checks if a and b overlap.
-- w and h mean width and height.
function checkCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)
	local ax2,ay2,bx2,by2 = ax1+aw, ay1+ah, bx1+bw, by1+bh
	return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

-- function triangulate(tableVertices)	
--  :
-- tableNewShape[tr]			--  ...
-- tableNewShape[tr].x1		-- 
-- tableNewShape[tr].y1		--
-- tableNewShape[tr].x2		--
-- tableNewShape[tr].y2		--
-- tableNewShape[tr].x3		--
-- tableNewShape[tr].y3		--
function triangulate(tableVertices)										            --      !!!
	--print("start triangulate function")													-- DEBUG
	if #tableVertices < 4 then                                                           --   2 
		return 0; 
	end
	
	local verN = 2;
	local ver1X = tableVertices[1];
	local ver1Y = tableVertices[2];	
	local tableNewShape = {};	
	
	for tr=1, ((#tableVertices/2)-2) do												--     = n-2 
		if tr==1 then
			--verN = verN+1;
			--print("--start triangulate compile")										-- DEBUG
			--print("--|--start verN= "..verN);											-- DEBUG			
		end
		
		tableNewShape[tr] = {};															--  
		tableNewShape[tr].x1 = ver1X;		
		tableNewShape[tr].y1 = ver1Y;		
		tableNewShape[tr].x2 = tableVertices[verN+(verN-1)]
		tableNewShape[tr].y2 = tableVertices[verN+verN]	
		verN = verN+1;
		--print("--|--verN= "..verN);														-- DEBUG
		tableNewShape[tr].x3 = tableVertices[verN+(verN-1)]	
		tableNewShape[tr].y3 = tableVertices[verN+verN]	
	end
	--print("--end triangulate compile")										            -- DEBUG
	--print("end triangulate function")													-- DEBUG	
	return tableNewShape;
end

--    body 
-- rayStart -  table (rayStart.x , rayStart.y)
-- return tableVerticesDone
function pointsIsLeftOrRight(tableVertices, rayStart, rayEnd)
	local tableVerticesDone = {};
	
	for v=1, #tableVertices/2 do														-- (v - vertex)
		-- rayStart -> rayEnd -> vertexN
		tableVerticesDone[v] = math.isLeftOrRightOrCenter( rayStart.x, rayStart.y, 
			rayEnd.x, rayEnd.y, 
			tableVertices[v+(v-1)], tableVertices[v+v] )
	end
	return tableVerticesDone;
end

function worldRayCastCallback1(fixture, x, y, xn, yn, fraction)
    local hit = {};
    hit.fixture = fixture;
    hit.x, hit.y = x, y;
    hit.xn, hit.yn = xn, yn;
    hit.fraction = fraction;

    table.insert(ray1.hitList, hit);

    return 1 -- Continues with ray cast through all shapes.
end

function worldRayCastCallback2(fixture, x, y, xn, yn, fraction)
    local hit = {};
    hit.fixture = fixture;
    hit.x, hit.y = x, y;
    hit.xn, hit.yn = xn, yn;
    hit.fraction = fraction;

    table.insert(ray2.hitList, hit);

    return 1 -- Continues with ray cast through all shapes.
end

globalEntityCount = 0;
function getGlobalCountId()
	return globalEntityCount
end

function love.load()
print("\n".."start love.load() ")

globalDt = 0      -- init
globalDtlua = 0      -- init
loveLoad()	
-- TEST 

print("\n".."end love.load() ")
end -- love.load()

function love.update(dt)    
-- print("\n".."start love.update() ")
    globalDt = dt    -- for test
    loveUpdate(dt)
-- print("\n".."end love.update() ")
end

function love.keypressed(key)
    loveKeypressed(key)
end

function love.mousepressed(x, y, button)
	if button == "l" then
	print("love.mousepressed")
		if ray1.x1 == 0 then																--    ray1.x1  ray1.y1
			ray1.x1 = love.mouse.getX();												--  ray1.x1  ray1.y1
			ray1.y1 = love.mouse.getY();
		else																						--   ray1.x1  ray1.y1
			ray1.x2 = love.mouse.getX();												--  ray1.x2  ray1.y2
			ray1.y2 = love.mouse.getY();
		end
	end
end

function love.focus(f)
    globalLoveFocus = f
end

function love.draw()
    loveDraw()
end


